/*
 * This Java source file was generated by the Gradle 'init' task.
 */
package HpdosClient;

import HpdosClient.MessageFormat.MessageConstants;
import HpdosClient.MessageFormat.RequestBuilder;
import hpdos.grpc.NetworkServiceGrpc;
import hpdos.grpc.Packet;
import hpdos.grpc.PacketFormatProto;
import hpdos.grpc.Request;
import io.grpc.ManagedChannel;
import io.grpc.ManagedChannelBuilder;

import java.sql.Timestamp;
import java.time.Instant;
import java.util.*;
import java.util.concurrent.*;

public class ClientRunner {
    public static final int parallelCount = 1;
    private final String clientID;

    public ClientRunner() {
        clientID = UUID.randomUUID().toString();
    }
    public String getGreeting() {
        return "Hello World!";
    }

    public String initClient(String id) {
        final ManagedChannel channel = ManagedChannelBuilder.
                forAddress(ConfigConstants.HOST, ConfigConstants.PORT)
                .usePlaintext()
                .build();
        String key = "dummy", value = "dummy";
        NetworkServiceGrpc.NetworkServiceBlockingStub stub = NetworkServiceGrpc.newBlockingStub(channel);
        ArrayList<Request> request = new ArrayList<>();

        // create a metadata block
        request.add(RequestBuilder.buildRequest(MessageConstants.METADATA_CREATE,
                0, value.length(), key,
                0, MessageConstants.METADATA_ACCESS_PRIVATE, this.clientID, value));
        Packet packet = RequestBuilder.buildPacket(request);
        Timestamp timestampCreateStart = Timestamp.from(Instant.now());
        Packet response = stub.createMetadata(packet);
        System.out.println(response);
        System.out.println("MDS create time taken in ms: " + (Timestamp.from(Instant.now()).getTime()
                - timestampCreateStart.getTime()));

        // read back the metadata
        request.clear();
        request.add(RequestBuilder.buildRequest(MessageConstants.METADATA_READ,
                0, 0, key, 0, MessageConstants.METADATA_ACCESS_PRIVATE, this.clientID, ""));
        packet = RequestBuilder.buildPacket(request);
        Timestamp timestampReadStart = Timestamp.from(Instant.now());
        response = stub.readMetadata(packet);
        System.out.println(response);
        System.out.println("MDS create time taken in ms: " + (Timestamp.from(Instant.now()).getTime()
                - timestampReadStart.getTime()));
        channel.shutdown();
        return id;
    }


    public static void main(String[] args) throws InterruptedException, ExecutionException {
        ClientRunner clientRunner = new ClientRunner();
        System.out.println(clientRunner.getGreeting());
        Thread.sleep(1000);
        ExecutorService executorService = Executors.newFixedThreadPool(parallelCount);
        Set<Callable<String>> callables = new HashSet<>();
        for (int i = 0; i < parallelCount; i++) {
            int finalI = i;
            callables.add(new Callable<String>() {
                @Override
                public String call() throws Exception {
                    return clientRunner.initClient(Integer.toString(finalI));
                }
            });
        }

        List<Future<String>> futures = executorService.invokeAll(callables);
        for (Future<String> future: futures) {
            System.out.println(future.get());
        }
//        clientRunner.initClient();
    }
}
